<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__canfd" kind="group">
    <compoundname>group_canfd</compoundname>
    <title>CAN FD       (CAN with Flexible Data-Rate)</title>
    <innergroup refid="group__group__canfd__macros">Macros</innergroup>
    <innergroup refid="group__group__canfd__functions">Functions</innergroup>
    <innergroup refid="group__group__canfd__data__structures">Data Structures</innergroup>
    <innergroup refid="group__group__canfd__enums">Enumerated Types</innergroup>
    <briefdescription>
<para>The CAN FD driver provides an easy method to access the CAN FD IP block registers and provides simple functionality for sending and receiving data between devices in the CAN FD network. </para>    </briefdescription>
    <detaileddescription>
<para>The CAN FD driver provides an API to configure the main features - mode, bit time, message buffers - and transmit and receive message in all modes:<itemizedlist>
<listitem><para>Classic CAN using 11-bit identifiers</para></listitem><listitem><para>Classic CAN using 29-bit identifiers</para></listitem><listitem><para>CAN Flexible Data using 11-bit identifiers</para></listitem><listitem><para>CAN Flexible Data using 29-bit identifiers.</para></listitem></itemizedlist>
</para><para><image name="canfd_solution.png" type="html" width="948px">CAN FD Solution</image>
 
</para>
<para><heading level="1">Configuration Considerations</heading></para>
<para>Specification of the sample code is as follows:<itemizedlist>
<listitem><para>Selectable CAN FD mode or CAN mode</para></listitem><listitem><para>Configurable CAN clock</para></listitem><listitem><para>Configurable CAN Bit rate</para></listitem><listitem><para>Configurable CAN FD Bit rate</para></listitem><listitem><para>Configurable Standard ID filter</para></listitem><listitem><para>Configurable Extended Message ID Filter</para></listitem><listitem><para>Tx-Rx Element Size : 8 bytes (CAN mode)</para></listitem><listitem><para>Tx-Rx Element Size : 64 bytes (CAN FD mode)</para></listitem><listitem><para>Rx FIFO configuration</para></listitem><listitem><para>Interrupts : <linebreak />
 CY_CANFD_RX_FIFO_0_NEW_MESSAGE (Message stored to Rx FIFO 0) <linebreak />
 CY_CANFD_RX_FIFO_1_NEW_MESSAGE (Message stored to Rx FIFO 1) <linebreak />
 CY_CANFD_RX_BUFFER_NEW_MESSAGE (Message stored to Dedicated Rx Buffer). <linebreak />
 Sends data of ID:0x200 periodically in the main(). Echobacks received data by incrementing the ID of the received packet in the receiving interrupt.(CanFDIrqHandler() <mdash /> CanFDCallbackRx())</para></listitem></itemizedlist>
</para>
<para><bold>Use ModusToolbox Device Configurator Tool to generate initialization code</bold></para>
<para>The steps to generate initialization code using the ModusToolbox Device Configurator Tool:</para><para><orderedlist>
<listitem><para>Launch the ModusToolbox Device Configurator Tool.</para></listitem><listitem><para>Switch to the Peripherals tab. Enable the CAN FD channel personality under Communication and enter Alias (default is canfd_0_chan_0).</para></listitem><listitem><para>Go to the Parameters Pane for the CAN FD Personality and configure it with the desired parameters (set the Clock Signal divider, set the bit timing configuration, set the other parameters per Configuration Considerations, etc).</para></listitem><listitem><para>Perform File-&gt;Save for the initialization code to generate.</para></listitem></orderedlist>
</para><para>Now, all required CAN FD initialization code and configuration prerequisites will be generated:</para><para><itemizedlist>
<listitem><para>The Peripheral Clock Divider assignment and analog routing are parts of the init_cycfg_all() routine. Place the call of the init_cycfg_all() function before using any CAN FD API functions to ensure initialization of all external resources required for the CAN FD operation.</para></listitem><listitem><para>The CAN FD configuration structure declaration is in the cycfg_peripherals.h file and its initialization is in the cycfg_peripherals.c file. The variable name is &lt;CAN_FD_Alias_Name&gt;_config (default is canfd_0_chan_0_config). It must be used with <ref kindref="member" refid="group__group__canfd__functions_1ga8a1f6cffafdd899861203d50d24e7b3e">Cy_CANFD_Init()</ref> function.</para></listitem><listitem><para>TX buffers structures are initialized. Use these structures to send data.</para></listitem></itemizedlist>
</para><para>For the CAN FD interrupt service routine, <ref kindref="member" refid="group__group__canfd__functions_1ga98d7d32a784ea4e395b366bd988a198f">Cy_CANFD_IrqHandler()</ref> can be used. It handles reading data from the dedicated RX buffers and RX FIFO buffers. Corresponding callback functions are called for error interrupts, RX interrupts and TX complete interrupt. Put the names of callback functions to the Callback functions parameters section. Put NULL if no callback function to be used. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Only RX interrupt sources are enabled by default. Use &lt;a href="group__group__canfd__functions.html#group__group__canfd__functions_1ga054d85e42f3f2440743c981dbc52ed0a"&gt;Cy_CANFD_SetInterruptMask()&lt;/a&gt; to enable other interrupt sources. &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Interrupt flags are set regardless of the interrupt enable register. Cy_CANFD_IrqHandler will check and process all supported interrupts when triggered with any enabled interrupt source.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><programlisting><codeline><highlight class="comment">/*<sp />CANFD<sp />interrupt<sp />handler<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />CanfdInterruptHandler(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Just<sp />call<sp />the<sp />IRQ<sp />handler<sp />with<sp />the<sp />current<sp />channel<sp />number<sp />and<sp />context<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__canfd__functions_1ga98d7d32a784ea4e395b366bd988a198f">Cy_CANFD_IrqHandler</ref>(CANFD0,<sp />0,<sp />&amp;context);</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting> Set up the interrupt handler to be called with CAN FD events. The CAN FD block has two interrupt lines which can be assigned to different interrupt sources using <ref kindref="member" refid="group__group__canfd__functions_1ga4f70384d4189cb8a2c95558844b3ad32">Cy_CANFD_SetInterruptLine()</ref>: canfd_0_interrupts0_0_IRQn and canfd_0_interrupts1_0_IRQn. Also, the CAN FD block has a consolidated interrupt canfd_0_interrupt0_IRQn. The following code shows how to set up the interrupt handler. <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Setup<sp />the<sp />CANFD<sp />interrupt<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Populate<sp />the<sp />configuration<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__sysint__t">cy_stc_sysint_t</ref><sp />irq_cfg<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.intrSrc<sp />*/</highlight><highlight class="normal"><sp />canfd_0_interrupts0_0_IRQn,<sp /></highlight><highlight class="comment">/*<sp />CAN<sp />FD<sp />interrupt<sp />number<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.intrPriority<sp />*/</highlight><highlight class="normal"><sp />3UL</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Hook<sp />the<sp />interrupt<sp />service<sp />routine<sp />and<sp />enable<sp />the<sp />interrupt<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(void)<sp /><ref kindref="member" refid="group__group__sysint__functions_1gab2ff6820a898e9af3f780000054eea5d">Cy_SysInt_Init</ref>(&amp;irq_cfg,<sp />&amp;CanfdInterruptHandler);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />NVIC_EnableIRQ(canfd_0_interrupts0_0_IRQn);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
</programlisting> </para>

<para><bold>Implement the initialization code manually</bold></para>
<para>Call <ref kindref="member" refid="group__group__canfd__functions_1ga8a1f6cffafdd899861203d50d24e7b3e">Cy_CANFD_Init()</ref> to initialize the CAN FD module. It initializes the CAN FD module with the configuration parameters, passed in the <ref kindref="compound" refid="structcy__stc__canfd__config__t">cy_stc_canfd_config_t</ref> structure. It consists of several elements to be defined first. <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__canfd__config__t">cy_stc_canfd_config_t</ref><sp />config<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.txCallback<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />NULL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.rxCallback<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />CAN_RxMsgCallback,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.errorCallback<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />NULL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.canFDMode<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.bitrate<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />&amp;bitrateConfig,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.fastBitrate<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />&amp;fastBitrateConfig,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.tdcConfig<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />&amp;tdcConfig,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.sidFilterConfig<sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />&amp;sidFiltersConfig,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.extidFilterConfig<sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />&amp;extidFiltersConfig,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.globalFilterConfig<sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />&amp;globalFilterConfig,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.rxBufferDataSize<sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__canfd__enums_1gga597fe2f69a8484277fd481ac5384ca7ca2a6fe8e5944a3c017b15cce584d421ee">CY_CANFD_BUFFER_DATA_SIZE_64</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.rxFIFO1DataSize<sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__canfd__enums_1gga597fe2f69a8484277fd481ac5384ca7ca2a6fe8e5944a3c017b15cce584d421ee">CY_CANFD_BUFFER_DATA_SIZE_64</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.rxFIFO0DataSize<sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__canfd__enums_1gga597fe2f69a8484277fd481ac5384ca7ca2a6fe8e5944a3c017b15cce584d421ee">CY_CANFD_BUFFER_DATA_SIZE_64</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.txBufferDataSize<sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__canfd__enums_1gga597fe2f69a8484277fd481ac5384ca7ca2a6fe8e5944a3c017b15cce584d421ee">CY_CANFD_BUFFER_DATA_SIZE_64</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.rxFIFO0Config<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />&amp;rxFifo0Config,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.rxFIFO1Config<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />&amp;rxFifo1Config,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.noOfRxBuffers<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />0x4u,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.noOfTxBuffers<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />0x2u,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.messageRAMaddress<sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />CY_CAN0MRAM_BASE,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.messageRAMsize<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />4096u</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
</programlisting>The <ref kindref="member" refid="group__group__canfd__functions_1ga8a1f6cffafdd899861203d50d24e7b3e">Cy_CANFD_Init()</ref> function also initializes the shared context structure used later with other API functions. <programlisting><codeline><highlight class="normal"><ref kindref="compound" refid="structcy__stc__canfd__context__t">cy_stc_canfd_context_t</ref><sp />context;<sp /></highlight><highlight class="comment">/*<sp />This<sp />is<sp />a<sp />shared<sp />context<sp />structure,<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />unique<sp />for<sp />each<sp />channel<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
</programlisting>Although the callback functions are optional, they are recommended for use, otherwise, there is no report to the API about any error and transmission or reception events. The example callback function sends received data back to the bus, incrementing ID by 1: <programlisting><codeline><highlight class="comment">/*<sp />CANFD<sp />reception<sp />callback<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />CAN_RxMsgCallback(</highlight><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />bRxFifoMsg,<sp />uint8_t<sp />u8MsgBufOrRxFifoNum,<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__canfd__rx__buffer__t">cy_stc_canfd_rx_buffer_t</ref>*<sp />pstcCanFDmsg)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(0<sp />==<sp />pstcCanFDmsg-&gt;<ref kindref="member" refid="structcy__stc__canfd__rx__buffer__t_1a602b97b15de68d54ccb557ed4c501e20">r0_f</ref>-&gt;<ref kindref="member" refid="structcy__stc__canfd__r0__t_1a80c311872aedfda473862d01643682e6">rtr</ref>)<sp /></highlight><highlight class="comment">/*<sp />Only<sp />for<sp />data<sp />frames<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Sets<sp />up<sp />the<sp />CANFD<sp />TX<sp />Buffer<sp />for<sp />response<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__canfd__t0__t">cy_stc_canfd_t0_t</ref><sp />t0registerMsg0<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />id<sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><sp />pstcCanFDmsg-&gt;<ref kindref="member" refid="structcy__stc__canfd__rx__buffer__t_1a602b97b15de68d54ccb557ed4c501e20">r0_f</ref>-&gt;<ref kindref="member" refid="structcy__stc__canfd__r0__t_1a82b8a4316d88b483958958bc6eccda38">id</ref><sp />+<sp />1,<sp /></highlight><highlight class="comment">/*<sp />Message<sp />ID<sp />is<sp />incremented*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />rtr<sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__canfd__enums_1gga9dc2150b5a115fd87cd60f538f7281ceac797e947012ac4b5d191f67b5095682c">CY_CANFD_RTR_DATA_FRAME</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />xtd<sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />pstcCanFDmsg-&gt;<ref kindref="member" refid="structcy__stc__canfd__rx__buffer__t_1a602b97b15de68d54ccb557ed4c501e20">r0_f</ref>-&gt;<ref kindref="member" refid="structcy__stc__canfd__r0__t_1ad82c419283c2f7f4f2ed1e8eafe50292">xtd</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />esi<sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__canfd__enums_1gga24bb5c7075c10594b4e276520f64f779a46390b4ec4de5f7c1819fe9f1a0ebbec">CY_CANFD_ESI_ERROR_ACTIVE</ref></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__canfd__t1__t">cy_stc_canfd_t1_t</ref><sp />t1registerMsg0<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />dlc<sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />pstcCanFDmsg-&gt;<ref kindref="member" refid="structcy__stc__canfd__rx__buffer__t_1ac4fdc02124190194f9093018dfffbc3e">r1_f</ref>-&gt;<ref kindref="member" refid="structcy__stc__canfd__r1__t_1ad2c446d9edb17be86dcb8c20606473a9">dlc</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />brs<sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />fdf<sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />(</highlight><highlight class="keyword">true</highlight><highlight class="normal">)<sp />?<sp /><ref kindref="member" refid="group__group__canfd__enums_1gga9a9a243726110708a6e61d77b7a86d1ea0053337533518903d9fa1ec0729a22d2">CY_CANFD_FDF_CAN_FD_FRAME</ref><sp />:<sp /><ref kindref="member" refid="group__group__canfd__enums_1gga9a9a243726110708a6e61d77b7a86d1ea16e079ea2b407c5c68f8dfd9f3075553">CY_CANFD_FDF_STANDARD_FRAME</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />efc<sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />mm<sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />0UL</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__canfd__tx__buffer__t">cy_stc_canfd_tx_buffer_t</ref><sp />txBuffer<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />t0_f<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />&amp;t0registerMsg0,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />t1_f<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />&amp;t1registerMsg0,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />data_area_f<sp />*/</highlight><highlight class="normal"><sp />pstcCanFDmsg-&gt;<ref kindref="member" refid="structcy__stc__canfd__rx__buffer__t_1a0db6cdd9b30082a0639b997703f2aec1">data_area_f</ref></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Sends<sp />the<sp />same<sp />message<sp />back<sp />with<sp />an<sp />incremented<sp />ID<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__canfd__functions_1gadf1ee9154fc5182edcaed69730fe23af">Cy_CANFD_UpdateAndTransmitMsgBuffer</ref>(CANFD0,<sp />0UL,<sp />&amp;txBuffer,<sp />0u,<sp />&amp;context);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />These<sp />parameters<sp />are<sp />not<sp />used<sp />in<sp />this<sp />snippet<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)bRxFifoMsg;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)u8MsgBufOrRxFifoNum;</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting>CAN FD IP block requires the configuration of a peripheral clock divider. The following code configures an 8-bit clock divider. The default peripheral clock frequency is 72 MHz. The desired divider value minus one must be passed. <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Setup<sp />CAN<sp />clock<sp />(cclk).</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />This<sp />clock<sp />is<sp />used<sp />as<sp />base<sp />clock<sp />of<sp />the<sp />CAN<sp />communication.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />Use<sp />divider<sp />3<sp />for<sp />24MHz</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />Use<sp />divider<sp />9<sp />for<sp /><sp />8MHz</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />DIVIDER_INDEX<sp />0u</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />DIVIDER_VALUE<sp />(9u<sp />-<sp />1u)<sp /></highlight><highlight class="comment">/*<sp />One<sp />less<sp />than<sp />divider<sp />value<sp />must<sp />be<sp />used<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__sysclk__clk__peripheral__funcs_1gacb66324e3191006f6d1cee8b29238fb2">Cy_SysClk_PeriphAssignDivider</ref>(PCLK_CANFD0_CLOCK_CAN0,<sp /><ref kindref="member" refid="group__group__sysclk__clk__peripheral__enums_1gga06138349be16d91fd5d00ded2f4592b8ad2299deae6e36a070de5a60368b319ad">CY_SYSCLK_DIV_8_BIT</ref>,<sp />DIVIDER_INDEX);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__sysclk__clk__peripheral__funcs_1gac67931844e6ec06b5ff88f4f3119e127">Cy_SysClk_PeriphSetDivider</ref>(<ref kindref="member" refid="group__group__sysclk__clk__peripheral__enums_1gga06138349be16d91fd5d00ded2f4592b8ad2299deae6e36a070de5a60368b319ad">CY_SYSCLK_DIV_8_BIT</ref>,<sp />DIVIDER_INDEX,<sp />DIVIDER_VALUE);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__sysclk__clk__peripheral__funcs_1ga8c626f11b583d8296516bbcf4a22f98e">Cy_SysClk_PeriphEnableDivider</ref>(<ref kindref="member" refid="group__group__sysclk__clk__peripheral__enums_1gga06138349be16d91fd5d00ded2f4592b8ad2299deae6e36a070de5a60368b319ad">CY_SYSCLK_DIV_8_BIT</ref>,<sp />DIVIDER_INDEX);</highlight></codeline>
</programlisting>The CAN FD block uses the Port 5 pins for receive (P5[0]) and transmit (P5[1]).<itemizedlist>
<listitem><para>Connect the specified High-Speed Input Output Multiplexer (HSIOM) selection to the pin.</para></listitem><listitem><para>Set the pins drive mode for RX and TX.</para></listitem></itemizedlist>
</para><para><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Assign<sp />pins<sp />for<sp />CAN<sp />FD<sp />RX<sp />and<sp />TX:<sp />P5[0]<sp />and<sp />P5[1].<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CANFD_PORT<sp /><sp /><sp /><sp /><sp /><sp />(P5_0_PORT)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CANFD_RX_NUM<sp /><sp /><sp /><sp />(P5_0_NUM)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CANFD_TX_NUM<sp /><sp /><sp /><sp />(P5_1_NUM)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__gpio__functions__init_1ga83a06264feed0e1042671a74339ea155">Cy_GPIO_SetHSIOM</ref>(CANFD_PORT,<sp />CANFD_RX_NUM,<sp />P5_0_CANFD0_TTCAN_RX0);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__gpio__functions__init_1ga83a06264feed0e1042671a74339ea155">Cy_GPIO_SetHSIOM</ref>(CANFD_PORT,<sp />CANFD_TX_NUM,<sp />P5_1_CANFD0_TTCAN_TX0);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__gpio__functions__gpio_1ga97e64dc8c45e7cd73e3012100d03b1fd">Cy_GPIO_SetDrivemode</ref>(CANFD_PORT,<sp />CANFD_RX_NUM,<sp /><ref kindref="member" refid="group__group__gpio__drive_modes_1gaf2fe5dc00ba1770b37e620a01169485c">CY_GPIO_DM_HIGHZ</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__gpio__functions__gpio_1ga97e64dc8c45e7cd73e3012100d03b1fd">Cy_GPIO_SetDrivemode</ref>(CANFD_PORT,<sp />CANFD_TX_NUM,<sp /><ref kindref="member" refid="group__group__gpio__drive_modes_1ga9e554ee7c43ac65a6d48274455b53823">CY_GPIO_DM_STRONG</ref>);</highlight></codeline>
</programlisting> For the CANFD interrupt service routine, the <ref kindref="member" refid="group__group__canfd__functions_1ga98d7d32a784ea4e395b366bd988a198f">Cy_CANFD_IrqHandler()</ref> can be used. It handles reading data from dedicated RX buffers and RX FIFO buffers. Corresponding callback functions are called for error interrupts, RX interrupts and TX complete interrupt. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Only RX interrupt sources are enabled by default. Use &lt;a href="group__group__canfd__functions.html#group__group__canfd__functions_1ga054d85e42f3f2440743c981dbc52ed0a"&gt;Cy_CANFD_SetInterruptMask()&lt;/a&gt; to enable other interrupt sources. &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Interrupt flags are set regardless of the interrupt enable register. Cy_CANFD_IrqHandler will check and process all supported interrupts when triggered with any enabled interrupt source.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><programlisting><codeline><highlight class="comment">/*<sp />CANFD<sp />interrupt<sp />handler<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />CanfdInterruptHandler(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Just<sp />call<sp />the<sp />IRQ<sp />handler<sp />with<sp />the<sp />current<sp />channel<sp />number<sp />and<sp />context<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__canfd__functions_1ga98d7d32a784ea4e395b366bd988a198f">Cy_CANFD_IrqHandler</ref>(CANFD0,<sp />0,<sp />&amp;context);</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting> Setup the interrupt handler to be called with the CAN FD events. The CAN FD block has two interupt lines, which can be assigned to different interrupt sources using <ref kindref="member" refid="group__group__canfd__functions_1ga4f70384d4189cb8a2c95558844b3ad32">Cy_CANFD_SetInterruptLine()</ref>: canfd_0_interrupts0_0_IRQn and canfd_0_interrupts1_0_IRQn. Also, the CAN FD block has a consolidated interrupt canfd_0_interrupt0_IRQn. The following code shows how to set up the interrupt handler. <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Setup<sp />the<sp />CANFD<sp />interrupt<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Populate<sp />the<sp />configuration<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__sysint__t">cy_stc_sysint_t</ref><sp />irq_cfg<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.intrSrc<sp />*/</highlight><highlight class="normal"><sp />canfd_0_interrupts0_0_IRQn,<sp /></highlight><highlight class="comment">/*<sp />CAN<sp />FD<sp />interrupt<sp />number<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.intrPriority<sp />*/</highlight><highlight class="normal"><sp />3UL</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Hook<sp />the<sp />interrupt<sp />service<sp />routine<sp />and<sp />enable<sp />the<sp />interrupt<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(void)<sp /><ref kindref="member" refid="group__group__sysint__functions_1gab2ff6820a898e9af3f780000054eea5d">Cy_SysInt_Init</ref>(&amp;irq_cfg,<sp />&amp;CanfdInterruptHandler);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />NVIC_EnableIRQ(canfd_0_interrupts0_0_IRQn);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
</programlisting> CAN FD has two bit rate settings, for arbitration and data phases. Both are configured with the same structure, containing a pre-scaler, time segment 1, time segment 2 and synchronization jump width. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The actual interpretation by the hardware of configured values is one more value than programmed. &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The bit rate configured for the CAN FD data phase must be higher or equal to the bit rate configured for the arbitration phase.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;The CAN time quantum (tq) may be programmed in the range of 1 to 32 CAN FD clock periods: tq = (prescaler + 1) mtq, where mtq is CAN FD block's clock period. The length of the bit time is (programmed values) [timeSegment1 + timeSegment2 + 3] tq. </verbatim><linebreak />
The example below shows the configuration with the 100 kbps arbitration bit rate and 200 kbps data bit rate. This assumes the peripheral clock frequency of 72 MHz divided by 9 to obtain the 8 MHz clock for the CAN FD block. <programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__canfd__bitrate__t">cy_stc_canfd_bitrate_t</ref><sp />bitrateConfig<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.prescaler<sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />10u<sp />-<sp />1u,<sp /><sp /></highlight><highlight class="comment">/*<sp />0<sp />to<sp />511<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.timeSegment1<sp /><sp />*/</highlight><highlight class="normal"><sp />5u<sp />-<sp />1u,<sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />0<sp />to<sp />255<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.timeSegment2<sp /><sp />*/</highlight><highlight class="normal"><sp />2u<sp />-<sp />1u,<sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />0<sp />to<sp />127<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.syncJumpWidth<sp />*/</highlight><highlight class="normal"><sp />2u<sp />-<sp />1u<sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />0<sp />to<sp />127<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__canfd__bitrate__t">cy_stc_canfd_bitrate_t</ref><sp />fastBitrateConfig<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.prescaler<sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />5u<sp />-<sp />1u,<sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />0<sp />to<sp />511<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.timeSegment1<sp /><sp />*/</highlight><highlight class="normal"><sp />5u<sp />-<sp />1u,<sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />0<sp />to<sp />255<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.timeSegment2<sp /><sp />*/</highlight><highlight class="normal"><sp />2u<sp />-<sp />1u,<sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />0<sp />to<sp />127<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.syncJumpWidth<sp />*/</highlight><highlight class="normal"><sp />2u<sp />-<sp />1u<sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />0<sp />to<sp />127<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__canfd__transceiver__delay__compensation__t">cy_stc_canfd_transceiver_delay_compensation_t</ref><sp />tdcConfig<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.tdcEnabled<sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.tdcOffset<sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />0,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.tdcFilterWindow<sp />*/</highlight><highlight class="normal"><sp />0</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
</programlisting>CAN FD driver provides API to setup Message ID filtering. There are standard ID and extended ID filters. The desired count of the filters of each type is specified in the <ref kindref="compound" refid="structcy__stc__canfd__config__t">cy_stc_canfd_config_t</ref> structure and is set once during block initialization. It is possible to change the configured filters settings with <ref kindref="member" refid="group__group__canfd__functions_1ga1bf5168980233f4e1f7ecb1661c68a7a">Cy_CANFD_SidFilterSetup()</ref> and <ref kindref="member" refid="group__group__canfd__functions_1gae832ebd1a54d9ed0ef2ce13cd14bda5b">Cy_CANFD_XidFilterSetup()</ref>. Use the <ref kindref="compound" refid="structcy__stc__id__filter__t">cy_stc_id_filter_t</ref> structure to set up one standard ID filter: <programlisting><codeline><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />MESSAGE_ID0<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(0x00000001UL)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />MESSAGE_ID1<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(0x00000010UL)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />MESSAGE_ID2<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(0x00000020UL)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />MESSAGE_ID3<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(0x00010010UL)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />RX_BUFFER_ELEMENT_1<sp /><sp />(0x0UL)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />RX_BUFFER_ELEMENT_2<sp /><sp />(0x1UL)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />RX_BUFFER_ELEMENT_3<sp /><sp />(0x2UL)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />RX_BUFFER_ELEMENT_4<sp /><sp />(0x3UL)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__id__filter__t">cy_stc_id_filter_t</ref><sp />stdIdFilters[]<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />stdIdFilter[0]<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.sfid2<sp />*/</highlight><highlight class="normal"><sp />RX_BUFFER_ELEMENT_1,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.sfid1<sp />*/</highlight><highlight class="normal"><sp />MESSAGE_ID0,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.sfec<sp /><sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__canfd__enums_1ggae5fe195a7883e282b211bc54e10977f0a37e10c3b20326fbfd1dcd08b2616c582">CY_CANFD_SFEC_STORE_RX_BUFFER</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.sft<sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__canfd__enums_1gga21b68fc58e117edbae073d981342566aab201278070016e4b6b9f8a063d6273ee">CY_CANFD_SFT_CLASSIC_FILTER</ref></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />},</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />stdIdFilter[1]<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.sfid2<sp />*/</highlight><highlight class="normal"><sp />RX_BUFFER_ELEMENT_2,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.sfid1<sp />*/</highlight><highlight class="normal"><sp />MESSAGE_ID1,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.sfec<sp /><sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__canfd__enums_1ggae5fe195a7883e282b211bc54e10977f0a37e10c3b20326fbfd1dcd08b2616c582">CY_CANFD_SFEC_STORE_RX_BUFFER</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.sft<sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />CY_CANFD_SFT_CLASSIC_FILTER</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__canfd__sid__filter__config__t">cy_stc_canfd_sid_filter_config_t</ref><sp />sidFiltersConfig<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.numberOfSIDFilters<sp />*/</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(stdIdFilters)<sp />/<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(stdIdFilters[0]),</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.sidFilter<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />stdIdFilters,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
</programlisting>Use the <ref kindref="compound" refid="structcy__stc__extid__filter__t">cy_stc_extid_filter_t</ref> structure to set up an extended ID filter: <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__canfd__f0__t">cy_stc_canfd_f0_t</ref><sp />filter0F0Config<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.efid1<sp />*/</highlight><highlight class="normal"><sp />MESSAGE_ID2,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.efec<sp /><sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__canfd__enums_1gga54cac9dc6e3b4b0ad9f833420dcd0d85a246b8ada4e053806603a033b7f0fb011">CY_CANFD_EFEC_STORE_RX_BUFFER</ref></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__canfd__f1__t">cy_stc_canfd_f1_t</ref><sp />filter0F1Config<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.efid2<sp />*/</highlight><highlight class="normal"><sp />RX_BUFFER_ELEMENT_3,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.eft<sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__canfd__enums_1gga572525e185ea030f605f74679256f342a4f439933bd71059964565d23557bf7ca">CY_CANFD_EFT_CLASSIC_FILTER</ref></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__canfd__f0__t">cy_stc_canfd_f0_t</ref><sp />filter1F0Config<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.efid1<sp />*/</highlight><highlight class="normal"><sp />MESSAGE_ID3,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.efec<sp /><sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__canfd__enums_1gga54cac9dc6e3b4b0ad9f833420dcd0d85a7343ba05b3674cd56229d842787e9830">CY_CANFD_EFEC_DISABLE</ref></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__canfd__f1__t">cy_stc_canfd_f1_t</ref><sp />filter1F1Config<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.efid2<sp />*/</highlight><highlight class="normal"><sp />RX_BUFFER_ELEMENT_4,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.eft<sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />CY_CANFD_EFT_CLASSIC_FILTER</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__extid__filter__t">cy_stc_extid_filter_t</ref><sp />extIdFilters[]<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />extIdFilter[0]<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.f0_f<sp />*/</highlight><highlight class="normal"><sp />&amp;filter0F0Config,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.f1_f<sp />*/</highlight><highlight class="normal"><sp />&amp;filter0F1Config</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />},</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />extIdFilter[1]<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.f0_f<sp />*/</highlight><highlight class="normal"><sp />&amp;filter1F0Config,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.f1_f<sp />*/</highlight><highlight class="normal"><sp />&amp;filter1F1Config</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__canfd__extid__filter__config__t">cy_stc_canfd_extid_filter_config_t</ref><sp />extidFiltersConfig<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />numberOfEXTIDFilters<sp />*/</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(extIdFilters)<sp />/<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(extIdFilters[0]),</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />extidFilter<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />extIdFilters,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />extIDANDMask<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />0x1fffffffUL</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
</programlisting>Message IDs that do not match any filter are received according to the global filter set up. The global filter can be set up to receive messages with standard and extended IDs to different FIFO buffers. It can be configured to reject remote frames, as shown below. <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__canfd__global__filter__config__t">cy_stc_canfd_global_filter_config_t</ref><sp />globalFilterConfig<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.nonMatchingFramesStandard<sp /><sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__canfd__enums_1gga5ce2c01ca9806831dc539727d173e59ca9f84f229041f327f023e9cb8e38b3398">CY_CANFD_ACCEPT_IN_RXFIFO_0</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.nonMatchingFramesExtended<sp /><sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__canfd__enums_1gga5ce2c01ca9806831dc539727d173e59caa461ec9511646d934effbd9c71bd97f1">CY_CANFD_ACCEPT_IN_RXFIFO_1</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.rejectRemoteFramesStandard<sp />*/</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.rejectRemoteFramesExtended<sp />*/</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
</programlisting>The RX FIFO buffers, FIFO 0 and FIFO 1 are configured once on block initialization using <ref kindref="compound" refid="structcy__en__canfd__fifo__config__t">cy_en_canfd_fifo_config_t</ref> structure. <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__en__canfd__fifo__config__t">cy_en_canfd_fifo_config_t</ref><sp />rxFifo0Config<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />mode<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__canfd__enums_1gga0017b4985b8b86ca85b9dca5d532803eacf888e2a229311116de20012e4fc7b05">CY_CANFD_FIFO_MODE_BLOCKING</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />watermark<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />0u,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />numberOfFifoElements<sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />1u,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />topPointerLogicEnabled<sp />*/</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__en__canfd__fifo__config__t">cy_en_canfd_fifo_config_t</ref><sp />rxFifo1Config<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />mode<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__canfd__enums_1gga0017b4985b8b86ca85b9dca5d532803eacf888e2a229311116de20012e4fc7b05">CY_CANFD_FIFO_MODE_BLOCKING</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />watermark<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />0u,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />numberOfFifoElements<sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />1u,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />topPointerLogicEnabled<sp />*/</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
</programlisting>The <ref kindref="compound" refid="structcy__stc__canfd__config__t">cy_stc_canfd_config_t</ref> structure is used to pass all configuration to <ref kindref="member" refid="group__group__canfd__functions_1ga8a1f6cffafdd899861203d50d24e7b3e">Cy_CANFD_Init()</ref> function. It is populated with pointers to other structures required and constants, defined before. <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__canfd__config__t">cy_stc_canfd_config_t</ref><sp />config<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.txCallback<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />NULL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.rxCallback<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />CAN_RxMsgCallback,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.errorCallback<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />NULL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.canFDMode<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.bitrate<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />&amp;bitrateConfig,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.fastBitrate<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />&amp;fastBitrateConfig,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.tdcConfig<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />&amp;tdcConfig,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.sidFilterConfig<sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />&amp;sidFiltersConfig,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.extidFilterConfig<sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />&amp;extidFiltersConfig,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.globalFilterConfig<sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />&amp;globalFilterConfig,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.rxBufferDataSize<sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__canfd__enums_1gga597fe2f69a8484277fd481ac5384ca7ca2a6fe8e5944a3c017b15cce584d421ee">CY_CANFD_BUFFER_DATA_SIZE_64</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.rxFIFO1DataSize<sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__canfd__enums_1gga597fe2f69a8484277fd481ac5384ca7ca2a6fe8e5944a3c017b15cce584d421ee">CY_CANFD_BUFFER_DATA_SIZE_64</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.rxFIFO0DataSize<sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__canfd__enums_1gga597fe2f69a8484277fd481ac5384ca7ca2a6fe8e5944a3c017b15cce584d421ee">CY_CANFD_BUFFER_DATA_SIZE_64</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.txBufferDataSize<sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__canfd__enums_1gga597fe2f69a8484277fd481ac5384ca7ca2a6fe8e5944a3c017b15cce584d421ee">CY_CANFD_BUFFER_DATA_SIZE_64</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.rxFIFO0Config<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />&amp;rxFifo0Config,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.rxFIFO1Config<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />&amp;rxFifo1Config,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.noOfRxBuffers<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />0x4u,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.noOfTxBuffers<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />0x2u,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.messageRAMaddress<sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />CY_CAN0MRAM_BASE,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.messageRAMsize<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />4096u</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
</programlisting>The <ref kindref="member" refid="group__group__canfd__functions_1ga8a1f6cffafdd899861203d50d24e7b3e">Cy_CANFD_Init()</ref> function initializes the CAN FD block by writing CAN FD configuration registers. <ref kindref="member" refid="group__group__canfd__functions_1ga8a1f6cffafdd899861203d50d24e7b3e">Cy_CANFD_Init()</ref> enables the RX interrupts for new message reception into the dedicated RX buffers, FIFO 0 and FIFO 1. The code example also shows the test mode configuration which can be used to enable the Loopback mode. See <ref kindref="member" refid="group__group__canfd__enums_1gac301ff6eab794c7f718822ef7c289483">cy_stc_canfd_test_mode_t</ref> for details. <ref kindref="member" refid="group__group__canfd__functions_1ga8a1f6cffafdd899861203d50d24e7b3e">Cy_CANFD_Init()</ref> sets test mode configuration to CY_CANFD_TEST_MODE_DISABLE. Remember to disable the echo functionality in the RX callback when using a loopback. <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__canfd__enums_1gga8e8bd7856fdc3566bbe2d0c43270c187a0835f4671848804d56b8d29607a5c3a4">CY_CANFD_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__canfd__functions_1ga8a1f6cffafdd899861203d50d24e7b3e">Cy_CANFD_Init</ref><sp />(CANFD0,<sp />0,<sp />&amp;config,<sp />&amp;context))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Error<sp />processing<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enables<sp />the<sp />configuration<sp />changes<sp />to<sp />set<sp />Test<sp />mode<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__canfd__functions_1gae0e9450addab2f45af99473022f32f59">Cy_CANFD_ConfigChangesEnable</ref>(CANFD0,<sp />0);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Sets<sp />the<sp />Test<sp />mode<sp />configuration<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__canfd__functions_1ga6e4fed4a894d0b61c38714569cc94f5c">Cy_CANFD_TestModeConfig</ref>(CANFD0,<sp />0,<sp /><ref kindref="member" refid="group__group__canfd__enums_1ggac301ff6eab794c7f718822ef7c289483aed426a65133a036a1cb85d131fbe5b56">CY_CANFD_TEST_MODE_DISABLE</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Disables<sp />the<sp />configuration<sp />changes<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__canfd__functions_1ga1960f8d0f6ce39fc1ee0c51b02933fe4">Cy_CANFD_ConfigChangesDisable</ref>(CANFD0,<sp />0);</highlight></codeline>
</programlisting>To send a CAN FD message, a TX buffer structure must be prepared which consists of the T0 and T1 registers and data array. <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Prepares<sp />a<sp />CANFD<sp />message<sp />to<sp />transmit<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />data[<ref kindref="member" refid="group__group__canfd__macros_1ga2ffb38faee5adf33871a30ad579404dc">CY_CANFD_MESSAGE_DATA_BUFFER_SIZE</ref>];</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Sets<sp />up<sp />the<sp />CANFD<sp />TX<sp />Buffer<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__canfd__t0__t">cy_stc_canfd_t0_t</ref><sp />t0registerMsg0<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />id<sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><sp />0x200,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />rtr<sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__canfd__enums_1gga9dc2150b5a115fd87cd60f538f7281ceac797e947012ac4b5d191f67b5095682c">CY_CANFD_RTR_DATA_FRAME</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />xtd<sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />(</highlight><highlight class="keyword">false</highlight><highlight class="normal">)<sp />?<sp /><ref kindref="member" refid="group__group__canfd__enums_1gga511e4ae64e16189bfe2e5828ae2d9f25adcba34faabea8d9f6866b65a6a3ffc9c">CY_CANFD_XTD_EXTENDED_ID</ref><sp />:<sp /><ref kindref="member" refid="group__group__canfd__enums_1gga511e4ae64e16189bfe2e5828ae2d9f25aba189a4f427a087b73a3fd75a80f19ee">CY_CANFD_XTD_STANDARD_ID</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />esi<sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__canfd__enums_1gga24bb5c7075c10594b4e276520f64f779a46390b4ec4de5f7c1819fe9f1a0ebbec">CY_CANFD_ESI_ERROR_ACTIVE</ref></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__canfd__t1__t">cy_stc_canfd_t1_t</ref><sp />t1registerMsg0<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />dlc<sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />15U,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />brs<sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />fdf<sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />(</highlight><highlight class="keyword">true</highlight><highlight class="normal">)<sp />?<sp /><ref kindref="member" refid="group__group__canfd__enums_1gga9a9a243726110708a6e61d77b7a86d1ea0053337533518903d9fa1ec0729a22d2">CY_CANFD_FDF_CAN_FD_FRAME</ref><sp />:<sp /><ref kindref="member" refid="group__group__canfd__enums_1gga9a9a243726110708a6e61d77b7a86d1ea16e079ea2b407c5c68f8dfd9f3075553">CY_CANFD_FDF_STANDARD_FRAME</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />efc<sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />mm<sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />0UL</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__canfd__tx__buffer__t">cy_stc_canfd_tx_buffer_t</ref><sp />txBuffer<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />t0_f<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />&amp;t0registerMsg0,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />t1_f<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp />&amp;t1registerMsg0,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />data_area_f<sp />*/</highlight><highlight class="normal"><sp />data</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Prepare<sp />data<sp />to<sp />send<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />data[0]<sp /><sp />=<sp />0x78563412UL;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />data[1]<sp /><sp />=<sp />0x11111111UL;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />data[2]<sp /><sp />=<sp />0x22222222UL;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />data[3]<sp /><sp />=<sp />0x33332222UL;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />data[4]<sp /><sp />=<sp />0x55554444UL;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />data[5]<sp /><sp />=<sp />0x77776666UL;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />data[6]<sp /><sp />=<sp />0x99998888UL;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />data[7]<sp /><sp />=<sp />0xBBBBAAAAUL;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />data[8]<sp /><sp />=<sp />0xDDDDCCCCUL;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />data[9]<sp /><sp />=<sp />0xFFFFEEEEUL;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />data[10]<sp />=<sp />0x78563412UL;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />data[11]<sp />=<sp />0x00000000UL;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />data[12]<sp />=<sp />0x11111111UL;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />data[13]<sp />=<sp />0x22222222UL;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />data[14]<sp />=<sp />0x33333333UL;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />data[15]<sp />=<sp />0x44444444UL;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting>To transmit CAN FD messages, the function <ref kindref="member" refid="group__group__canfd__functions_1gadf1ee9154fc5182edcaed69730fe23af">Cy_CANFD_UpdateAndTransmitMsgBuffer()</ref> is used. The buffer status can be retrieved by <ref kindref="member" refid="group__group__canfd__functions_1gac8e45fcaaa5a129375cafc3184ba7a2c">Cy_CANFD_GetTxBufferStatus()</ref>. It is possible to set a callback function which will be notified whenever a message transmission has been completed. <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal">(;;)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Sends<sp />the<sp />prepared<sp />data<sp />using<sp />tx<sp />buffer<sp />1<sp />and<sp />waits<sp />for<sp />1000ms<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__canfd__functions_1gadf1ee9154fc5182edcaed69730fe23af">Cy_CANFD_UpdateAndTransmitMsgBuffer</ref>(CANFD0,<sp />0u,<sp />&amp;txBuffer,<sp />1u,<sp />&amp;context);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__syslib__functions_1gaad1c32546fdb0e3c6fa8b46fb95843b5">Cy_SysLib_Delay</ref>(1000u);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
</programlisting> </para>


<para><heading level="1">More Information</heading></para>
<para>For more information on the CAN FD peripheral, refer to the technical reference manual (TRM).</para>

<para><heading level="1">MISRA-C Compliance</heading></para>
<para>The CAN FD driver does not have any specific deviations.</para>

<para><heading level="1">Changelog</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Version&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Changes&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Reason for Change &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.10 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated of the &lt;a href="group__group__canfd__functions.html#group__group__canfd__functions_1ga8a1f6cffafdd899861203d50d24e7b3e"&gt;Cy_CANFD_Init()&lt;/a&gt; functions &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Allow initing CANFD with 0 number of SID/XID filters  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated description of the &lt;a href="group__group__canfd__functions.html#group__group__canfd__functions_1ga8a1f6cffafdd899861203d50d24e7b3e"&gt;Cy_CANFD_Init()&lt;/a&gt; and &lt;a href="group__group__canfd__functions.html#group__group__canfd__functions_1ga0849b023b3b145ede68d057561a2aa32"&gt;Cy_CANFD_DeInit()&lt;/a&gt; functions &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation update and clarification   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Initial version &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>